import { style as _style } from 'antd/lib/button/style';
import _default from 'antd/lib/button';

import React from 'react';
import Toolbar from '../Toolbar';
import RemoveButton from '../RemoveButton';
import UpdateButton from '../UpdateButton';
import CreateButton from '../CreateButton';
import TableQuerySwitch from '../TableQuerySwitch';
var Group = _default.Group;


export default function DefaultToolbar() {
	return React.createElement(Toolbar, {
		left: React.createElement(
			Group,
			null,
			React.createElement(CreateButton, null),
			React.createElement(UpdateButton, null),
			React.createElement(RemoveButton, null)
		),
		right: React.createElement(TableQuerySwitch, null)
	});
}