'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withModalStore;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoist = require('../hoist');

var _hoist2 = _interopRequireDefault(_hoist);

var _ModalStoreContext = require('./ModalStoreContext');

var _ModalStoreContext2 = _interopRequireDefault(_ModalStoreContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withModalStore() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var _options$prop = options.prop,
	    prop = _options$prop === undefined ? 'modalStore' : _options$prop;

	return function createModalStoreComponent(WrappedComponent) {
		var _dec, _class, _class2, _temp;

		var WithModalStore = (_dec = (0, _hoist2.default)(WrappedComponent), _dec(_class = (_temp = _class2 = function (_Component) {
			_inherits(WithModalStore, _Component);

			function WithModalStore() {
				_classCallCheck(this, WithModalStore);

				return _possibleConstructorReturn(this, (WithModalStore.__proto__ || Object.getPrototypeOf(WithModalStore)).apply(this, arguments));
			}

			_createClass(WithModalStore, [{
				key: 'render',
				value: function render() {
					var _this2 = this;

					return _react2.default.createElement(
						_ModalStoreContext2.default.Consumer,
						null,
						function (modalStore) {
							var modalStoreProp = _defineProperty({}, prop, modalStore);
							return _react2.default.createElement(WrappedComponent, _extends({}, (0, _hoist.extractRef)(_this2.props), modalStoreProp));
						}
					);
				}
			}]);

			return WithModalStore;
		}(_react.Component), _class2.defaultProps = _extends({}, WrappedComponent.defaultProps), _temp)) || _class);

		return WithModalStore;
	};
}