import _omit from 'lodash/omit';
import routerStore from '../stores/routerStore';


export default function clearSortedInfo(appConfig) {
	var _appConfig$api = appConfig.api,
	    sortKey = _appConfig$api.sortKey,
	    orderKey = _appConfig$api.orderKey;
	var location = routerStore.location;

	location.query = _omit(location.query, [sortKey, orderKey]);
}