'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withModalStoreProvider;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoist = require('../hoist');

var _hoist2 = _interopRequireDefault(_hoist);

var _ModalStore = require('../../stores/ModalStore');

var _ModalStore2 = _interopRequireDefault(_ModalStore);

var _ModalStoreContext = require('./ModalStoreContext');

var _ModalStoreContext2 = _interopRequireDefault(_ModalStoreContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withModalStoreProvider() {
	return function createModalStoreProviderComponent(WrappedComponent) {
		var _dec, _class, _class2, _temp;

		var WithModalStoreProvider = (_dec = (0, _hoist2.default)(WrappedComponent), _dec(_class = (_temp = _class2 = function (_Component) {
			_inherits(WithModalStoreProvider, _Component);

			function WithModalStoreProvider(props) {
				_classCallCheck(this, WithModalStoreProvider);

				var _this = _possibleConstructorReturn(this, (WithModalStoreProvider.__proto__ || Object.getPrototypeOf(WithModalStoreProvider)).call(this, props));

				var modalStore = props.modalStore;

				_this.modalStore = new _ModalStore2.default(modalStore);
				return _this;
			}

			_createClass(WithModalStoreProvider, [{
				key: 'render',
				value: function render() {
					var modalStore = this.modalStore,
					    props = this.props;

					var _ = props.modalStore,
					    other = _objectWithoutProperties(props, ['modalStore']);

					return _react2.default.createElement(
						_ModalStoreContext2.default.Provider,
						{ value: modalStore },
						_react2.default.createElement(WrappedComponent, _extends({}, (0, _hoist.extractRef)(other), { modalStore: modalStore }))
					);
				}
			}]);

			return WithModalStoreProvider;
		}(_react.Component), _class2.propTypes = {
			modalStore: _propTypes2.default.object
		}, _temp)) || _class);

		return WithModalStoreProvider;
	};
}